from funcionesSimELectrica import *
from funcionesSimFisica import *
from scipy.integrate import cumulative_trapezoid 

import matplotlib.pyplot as plt
import numpy as np


__author__ = 'Oscar Suescun' 

lts_path = "C:/Users/osuescuneli/AppData/Local/Programs/ADI/LTspice/LTspice.exe"

'''
Esto sirve para hacer debug del sistema y ver como se comportan 
las funciones para la 

'''
if __name__ == '__main__':
    tiempoSimulacion = 10e-3
    step = tiempoSimulacion / 1e6

    numeroModulos = 2

    longitudBobina = 53.21e-3 # m
    diametroInteriorBobina = 6.035e-3 * 2 # m
    espirasBobina = 500
    diametroCuBobina = 0.8e-3 # m

    longitudVastago = 96e-3 # m
    diametroVastago = 3.045e-3 * 2 # m
        
    Tension = 30 # V
    Capacitancia = 500e-3 # F

    masa = calcular_masa(diametroVastago, longitudVastago)
    anguloDisparo = 40


    resistencia = calcular_resistencia(diametroCuBobina, longitudBobina,
                                       diametroInteriorBobina, espirasBobina)
    
    reluctancia = np.mean(reluctancia_funcX(longitudVastago, diametroVastago,
                                    longitudBobina, diametroInteriorBobina,
                                    diametroCuBobina, espirasBobina))
    
    inductancia = espirasBobina**2 / reluctancia

    tiempo = np.arange(0,tiempoSimulacion, step)
    
    corriente = solver_manual(Tension, resistencia, inductancia, Capacitancia, tiempo)
    fuerza = fuerza_magnetica(corriente, reluctancia, espirasBobina, diametroVastago)

    aceleracion = []

    for i in np.arange(numeroModulos):
        
        aceleracion = np.append(aceleracion, calcular_aceleracion(masa, anguloDisparo, fuerza)) 
        
        if i == 0:aceleracion[aceleracion<0] = 0 # Evitar que la aceleracion sea negativa en la primera vuelta
        else:pass

        velocidad = cumulative_trapezoid(aceleracion,tiempo,initial=0)
        posicion = cumulative_trapezoid(velocidad, tiempo, initial=0)

        idx = posicion <= longitudBobina*(i+1)

        tiempo = tiempo[idx]                # Recorto los vectores
        posicion = posicion[idx]            # para tener en cuenta
        velocidad = velocidad[idx]          # que el vastago recorre
        aceleracion = aceleracion[idx]      # la longitud de la bobina




